                                           fl

{
USB Bus I/F Chip HC375

    PropForth 5.5       
  2015/08/06 16:27:06
    
          
                 CH375 Module    
                 ------------
Propeller        |       Vcc|--- 5V
    P0  ---------|Tx        |
    P1  ---------|Rx        |    (I seems Tx/Rx is pulled up to 3.3V)
                 |    Gnd   |
                 ------------
                       |
                      GND 
             
serial  9600bps  Noparity Startbit1 Databit9 Stopbit1
time ------------------------------------------------------------>>
-------       ---------                                    ------------
       |     |         |                                  |
       |     |         |                                  | 
        -----           ----------------------------------
 idle   start bit0 bit1 bit2 bit3 bit4 bit5 bit6 bit7   |   stop  idle
         bit                                            |    bit
       (always "0")                                     |   (always "1")
                                                        |
                                                       Control bit(command:1, data:0)
}
\ =========================================================================== 
\ Constants 
\ =========================================================================== 
0 wconstant Rx
1 wconstant Tx
2 wconstant INT
INT >m constant INTm
d9600 constant baud

d4096 wconstant MAX_SECTOR_SIZE
d64 wconstant CH375_BLOCK_SIZE

\ Operation state
h51 wconstant SUCCESS
h5F wconstant ABORT

\ command
1 wconstant GET_IC_VER
2 wconstant SET_BAUD_RATE
3 wconstant ENTER_SLEEP
5 wconstant RESET_ALL
6 wconstant CHECK_EXIST
hA wconstant GET_MAX_LUN
hB wconstant SET_DISK_LUN
hB wconstant SET_PKT_P_SEC

h15 wconstant SET_USB_MODE
h16 wconstant TEST_CONNECT
h17 wconstant ABORT_NAK
h22 wconstant GET_STATUS

h28 wconstant RD_USB_DATA
h2B wconstant WR_USB_DATA7

h51 wconstant DISK_INIT
h53 wconstant DISK_SIZE
h54 wconstant DISK_READ
h55 wconstant DISK_RD_GO
h56 wconstant DISK_WRITE
h57 wconstant DISK_WR_GO
h58 wconstant DISK_INQUERY
h59 wconstant DISK_READY
h5A wconstant DISK_R_SENSE
 
\ common interruption
h14 wconstant USB_INT_SUCCESS
h15 wconstant USB_INT_CONNECT
h16 wconstant USB_INT_DISCONNECT
h17 wconstant USB_INT_BUF_OVER
h18 wconstant USB_INT_USB_READY
h1D wconstant USB_INT_DISK_READ
h1E wconstant USB_INT_DISK_WRITE
h1F wconstant USB_INT_DISK_ERR

\ =========================================================================== 
\ Variables 
\ =========================================================================== 
variable buffer 4 allot
wvariable BlockPerSector
wvariable BytePerSector
variable TotalSize

\ =========================================================================== 
\ Main 
\ =========================================================================== 
\ Transmit
\ ( n1 n2 -- )  n1:sending data n2:hdserialStruct's name 
lockdict create a_Tx_CH375 forthentry
$C_a_lxasm w, h127  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z8i[ZB l, z20yPO8 l, z8i[eB l, z1SyLI[ l, zfyPO1 l, z1biPS] l, z2WyPbB l, z2WiPv[ l,
z20iPyk l, z1YVPO1 l, z1rixn\ l, z3riPv[ l, zbyPO1 l, z3[yPfS l, z1SyLI[ l, z1[ixn\ l,
z1SV01X l, 0 l, 0 l, zG0 l,
freedict

\ Receive
\ ( n1 -- n2 )  n1:hdserialStruct's name  n2:receive data
lockdict create a_Rx_CH375 forthentry
$C_a_lxasm w, h126  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z8i[ZB l, z20yPO4 l, z8i[eB l, z2WyPW8 l, z2WyPO0 l, z2WiPf[ l, zbyPb2 l, z20iPf[ l,
z3jF[f\ l, z3nF[f\ l, z20iPik l, z3riPf[ l, z1YF[il l, zbyPO1 l, z1vyPQ0 l, z3[yP[U l,
z1SV01X l, 0 l, 0 l,
freedict

\ Transmit and Receive with INT
\ ( n1 n2 n3 -- n4 )  n1:sending data n2:iINT-pin n3:hdserialStruct's name   n4:interruption data
lockdict create a_Tx_CH375_INT forthentry
$C_a_lxasm w, h139  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z8i]ZB l, z20yPO4 l, z8i]eB l, z20yPO4 l, z8i]mB l, z1SyLI[ l, z2Wy]r1 l, zfi]uB l,
z1SyLI[ l, zfyPO1 l, z1biPSr l, z2WyPbB l, z2WiPvn l, z20iPyk l, z1YVPO1 l, z1rixnp l,
z3riPvn l, zbyPO1 l, z3[yPfX l, z1YF]yl l, z1SQ04] l, z2WyPb8 l, z2WiPvn l, zbyPr2 l,
z20iPvn l, z3jF]fo l, z3nF]fo l, z20iPyk l, z3riPvn l, z1YF]il l, zbyPO1 l, z1vyPQ0 l,
z3[yPfi l, 0 l, 0 l, 0 l, 0 l, zG0 l,
freedict

{
half duplex serial structure for CH375
00 - 03 -- bitticks
04 - 07 -- rx pin mask
08 - 0B -- tx pin mask
}
\ hdserialStruct X ( baud rxpin txpin -- )   X is structure's name
: hdserialStruct
	lockdict variable 8 allot lastnfa nfa>pfa 2+ alignl freedict
	tuck swap >m swap 8 + L!
	tuck swap >m swap 4 + L!
	swap clkfreq swap u/ swap L!
;

\ Build serial-structure
baud Rx Tx hdserialStruct serial_CH375

\ Transmit command
\ ( n1 -- ) n1:command
: comTransmit h100 or serial_CH375 a_Tx_CH375 ;
\ Transmit data
\ ( n1 -- ) n1:data
: dataTransmit serial_CH375 a_Tx_CH375 ;
\ Transmit command and wait INT-signal
\ ( n1 -- ) n1:data
: comTransmit_INT h100 or serial_CH375 a_Tx_CH375 begin INTm ina COG@ and 0= until ;
\ Receive data
\ ( -- n1 ) n1:data
: Receive serial_CH375 a_Rx_CH375 ;

\ Display chip and firmware version
\ ( -- )
: version GET_IC_VER comTransmit Receive h3F and ;
 
\ Check if CH375communication operate finely
\ ( n1 -- ) n1:value 
: comCheck 
dup ." Transmitted value:" . cr dup
CHECK_EXIST comTransmit dataTransmit
Receive dup ." receiveed value:" . cr invert hFF and =           
if
     ." Received value is inverted; Connection to CH375 is successfull." cr
else
     ." Received value is NOT inverted; Connection to CH375 -- Fault"
then
cr
;     

\ Get USB-status
\ ( -- )
: USB_status GET_STATUS comTransmit Receive ;

\ Set USB-mode
\ ( -- n1 ) n1:result code [common interruption]
: setUSB
SET_USB_MODE comTransmit 6 dataTransmit 
Receive 
;
 
\ Reset CH375
\ ( -- )
: reset 
RESET_ALL comTransmit d50 delms 
;

\ Initialize disk
\ ( -- )
: init_disk DISK_INIT comTransmit ;


\ ----------------------------------------------------------------------------------------------------------
: TEXT4 c" TEXT4.TXT" ;
: wrData c" May the PropForth5.5 be with you!" ;

\ --- chip version and communication check --- 
: deviceCheck
hex
." chip and firmware version:h" version . cr
hA8 comCheck
cr 
;

\ Reset CH375
: RESET
reset
." If USB-device is connected, LED on CH375-board is off by H/W reset" cr cr
;

\ Set USB-Mode
: Set_USBmode
\ Wait until comuunication is ok
begin CHECK_EXIST comTransmit hA8 dataTransmit Receive h57 = until
     
setUSB 
dup SUCCESS =
if
     drop
     \ Command is successfill
     USB_status dup USB_INT_CONNECT =
     if
          ." Detected USB device" cr
          ." If connected USB-device, LED on CH375-board is on." cr
          drop 
     else
          ." USB device not present. code:h" . cr
          ." Or Fault to USB mode" cr
     then          
else
     ." CH375 Error!!  Error code:h" .  cr
then     
cr
;

\ Display Disk size
: DiskSize
\ Initialize Disk
DISK_INIT comTransmit_INT d10 delms USB_status USB_INT_SUCCESS =
if
     DISK_SIZE comTransmit_INT USB_status USB_INT_SUCCESS =
     if
          \ Get physical capability
          RD_USB_DATA comTransmit
          \ Reading at first is length of following data
          Receive Receive Receive Receive Receive Receive Receive Receive Receive
          8 ST@ 8 =
          if
               1 ST@
               4 over =
               if 
                    d1024 CH375_BLOCK_SIZE /
               else
                    8 over =
                    if 
                         d2048 CH375_BLOCK_SIZE /
                    else
                         h10 over =
                         if 
                              d4096 CH375_BLOCK_SIZE /
                         else 
                              d512 CH375_BLOCK_SIZE /
                         then
                    then
               then
               nip
               dup BlockPerSector W!
               decimal
               ." BlockPerSector:" . cr
               ." BytePerSector" BlockPerSector W@ CH375_BLOCK_SIZE * . cr
               ." TotalSize:" 
               7 ST@ 8 lshift TotalSize L! 
               6 ST@ TotalSize L@ or 8 lshift TotalSize L!
               5 ST@ TotalSize L@ or 8 lshift TotalSize L!
               4 ST@ TotalSize L@ or 
               BlockPerSector W@ CH375_BLOCK_SIZE * * dup . cr TotalSize L!
               3drop 3drop 3drop
               hex
          else
               ." Error!!"
          then
     else
          ." Error!! "
     then
else
     ." Fail to initialize DISK"
then
cr
;     
     



     
{
Transmit
( n1 n2 -- )  n1:sending data n2:hdserialStruct's name 
Using register inside
       $C_treg2:loop counter
       $C_treg3:bit counter
       $C_treg4:ticks
       
fl
build_BootOpt :rasm
          rdlong    __bitticks , $C_stTOS
          add       $C_stTOS , # 8
          rdlong    __txmask , $C_stTOS
          spop
          
          \ Add startbit
          shl       $C_stTOS , # 1
          \ Add stopbit
          or        $C_stTOS , __stopbit
          mov       $C_treg2 , # d11
          mov       $C_treg4 , __bitticks
          add       $C_treg4 , cnt

__txloop
          test      $C_stTOS , # 1 wz
          muxz      dira , __txmask
          waitcnt   $C_treg4 , __bitticks
          shr       $C_stTOS , # 1
          djnz      $C_treg2 , # __txloop
          spop
          
          andn      dira , __txmask
          jexit

__bitticks
     0
__txmask
     0
__stopbit
     h400
     
;asm a_Tx_CH375 


Receive
( n1 -- n2 )  n1:hdserialStruct's name  n2:receive data

Using register inside
       $C_treg1:loop counter
       $C_treg2:next bit count(1st:1.25bit, 2nd-8th:1bit)
 
fl
build_BootOpt :rasm
          rdlong    __bitticks , $C_stTOS
          add       $C_stTOS , # 4
          rdlong    __rxmask , $C_stTOS
          
          mov       $C_treg1 , # 8
          mov       $C_stTOS , # 0
          mov       $C_treg2 , __bitticks
          shr       $C_treg2 , # 2
          add       $C_treg2 , __bitticks

          \ Wait from hi to lo transition
          waitpeq   __rxmask , __rxmask 
          waitpne   __rxmask , __rxmask

          \ first loop tick count (1.25bit+cnt)
          add       $C_treg2 , cnt
__rxloop
          \ 1bit+cnt
          waitcnt   $C_treg2 , __bitticks
          test      __rxmask , ina wz
          shr       $C_stTOS , # 1
          muxnz     $C_stTOS , # h80
          djnz      $C_treg1 , # __rxloop
          
          jexit
          
__bitticks
     0
__rxmask
     0
     
;asm a_Rx_CH375 
}


